/*
 * Copyright (C) 2020 Loongson Technology Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __ASM_PERCPU_H
#define __ASM_PERCPU_H

#ifdef CONFIG_CPU_LOONGSON64
/* use r21 for fast access */
register unsigned long __my_cpu_offset __asm__("$21");
static inline void set_my_cpu_offset(unsigned long off)
{
	__my_cpu_offset = off;
	csr_writeq(off, LOONGARCH_CSR_KS4);
}
#else
#define set_my_cpu_offset(x) do {} while (0)
#endif

#include <asm-generic/percpu.h>

#endif /* __ASM_PERCPU_H */
